//+------------------------------------------------------------------+
//|                               Copyright  2016, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//|                         Donate / Support:  http://goo.gl/cEP5h5  | 
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |                    
//|                                          mario.jemic@gmail.com   |
//|                     BitCoin: 15VCJTLaz12Amr7adHSBtL9v8XomURo9RF  |
//+------------------------------------------------------------------+

#property indicator_buffers 5
#property indicator_chart_window

extern color   GannSwing_Color = clrYellow;

double GannSwing[];
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];

bool DebugMode = false;

int init(){
   
   IndicatorShortName("GannSwing");
   
   if (DebugMode) int DrawMode = DRAW_ARROW; else DrawMode = DRAW_NONE;
   
   SetIndexStyle(0,DRAW_SECTION,STYLE_SOLID,2,clrYellow);
   SetIndexBuffer(0,GannSwing);
   SetIndexLabel(0,"Gann Swing");
   
   SetIndexStyle(1,DrawMode,STYLE_SOLID,2,clrDodgerBlue);
   SetIndexArrow(1,108);
   SetIndexBuffer(1,Buffer1);
   SetIndexLabel(1,"Buffer1");
   
   SetIndexStyle(2,DrawMode,STYLE_SOLID,2,clrRed);
   SetIndexArrow(2,108);
   SetIndexBuffer(2,Buffer2);
   SetIndexLabel(2,"Buffer2");
   
   SetIndexStyle(3,DrawMode,STYLE_SOLID,2,clrLime);
   SetIndexArrow(3,159);
   SetIndexBuffer(3,Buffer3);
   SetIndexLabel(3,"Buffer3");
   
   SetIndexStyle(4,DrawMode,STYLE_SOLID,2,clrOrange);
   SetIndexArrow(4,159);
   SetIndexBuffer(4,Buffer4);
   SetIndexLabel(4,"Buffer4");
   
   return(0);
}

int deinit(){
   ObjectsDeleteAll();
   return(0);
}

int start()
  {
   
   int i;
   int counted_bars=IndicatorCounted();
   int limit = Bars-counted_bars-1;

   for(i=limit; i>0; i--){ ResetBuffers(i); }

   int previousPeak, previousThrough;
   int direction = 0;
   
   for(i=limit; i>0; i--){
      
      // 1.Two consecutive Higher High candles indicate Upswing
      if (direction!=1 && High[i] > High[i+1] && High[i+1] > High[i+2]){
         Buffer1[i] = High[i]; // This buffer stores the direction change to up
         direction = 1; // Up
         previousPeak = i; // By default the first peak (high of candle) when the direction changes is this candle
         GannSwing[i] = High[i];
      }
      
      // 2.Two consecutive Lower Low candles indicate Downswing
      else if (direction!=2 && Low[i] < Low[i+1] && Low[i+1] < Low[i+2]){
         Buffer2[i] = Low[i]; // This buffer stores the direction change to up
         direction = 2; // Down
         previousThrough = i; // By default the first peak (high of candle) when the direction changes is this candle
         GannSwing[i] = Low[i];
      }
      
      // 3.Swing lines connect either Highs or Lows of individual bars - never Open or Close
      
      // 4.If the next bar has a higher high and a higher low (or the same low) when
      // compared to the previous bar, then the swing line goes up connecting the high of the next bar
      if (direction==1 && Buffer1[i]==EMPTY_VALUE && High[i] > High[i+1] && Low[i] >= Low[i+1]){
         Buffer3[i] = High[i]; // This buffer stores this case's high for debugging purposes
         if (High[i] > High[previousPeak]){ // If this High is higher than the previously stored high, then this will be the New Peak
            GannSwing[previousPeak] = EMPTY_VALUE; // The previous peak is deleted
            previousPeak = i; // The previous peak for continuing the analysis is now this candle
            GannSwing[i] = High[i];
         }
      }
     
      // 5. If the next bar has a lower high (or same high) and a
      // lower low when compared to the previous bar, then the swing line goes down connecting the low of the next bar
      else if (direction==2 && Buffer2[i]==EMPTY_VALUE && High[i] <= High[i+1] && Low[i] < Low[i+1]){
         Buffer4[i] = Low[i]; // This buffer stores this case's low for debugging purposes
         if (Low[i] < Low[previousThrough]){ // If this Low is lower than the previously stored low, then this will be the New Through
            GannSwing[previousThrough] = EMPTY_VALUE; // The previous through is deleted
            previousThrough = i; // The previous through for continuing the analysis is now this candle
            GannSwing[i] = Low[i];
         }
      }
      
      // 6.If the next bar is an inside bar (lower high and higher low), ignore it and dont plot a line on it at all  wait for the next bar.
      
      // 7.If the next br is an outside bar (higher high and lower low)
      if (High[i] > High[i+1] && Low[i] < Low[i+1]){
         // plot a swing line on the high of an outside bar if the following bar (one after the outside bar) is lower
         if (direction==1 && High[i] > High[previousPeak]){ // If this High is higher than the previously stored high, then this will be the New Peak
            GannSwing[previousPeak] = EMPTY_VALUE; // The previous peak is deleted
            previousPeak = i; // The previous peak for continuing the analysis is now this candle
            GannSwing[i] = High[i];
         }
         // OR plot a swing line on the low of an outside bar if the following bar (one after the outside bar) is higher
         if (direction==2 && Low[i] < Low[previousThrough]){ // If this Low is lower than the previously stored low, then this will be the New Through
            GannSwing[previousThrough] = EMPTY_VALUE; // The previous through is deleted
            previousThrough = i; // The previous through for continuing the analysis is now this candle
            GannSwing[i] = Low[i];
         }
      }

   } // for
   
//----
   return(0);
}

void ResetBuffers(int shift){
 GannSwing[shift] = EMPTY_VALUE;
 Buffer1[shift]   = EMPTY_VALUE;
 Buffer2[shift]   = EMPTY_VALUE;
 Buffer3[shift]   = EMPTY_VALUE;
 Buffer4[shift]   = EMPTY_VALUE;
 return;
}